/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef RULES_H
#define RULES_H

/* the amout the score is incremented on certain events */
#define ROIDKILL 1
#define ROIDSPLIT 2
#define SHIPKILL -1
#define ENEMYKILL 3

extern int score;
extern int lives;

extern int engine;
extern int gun;
extern int wave;

void rules_init();
void rules_action(int act);
void rules_shutdown();
void rules_draw();
void rules_update();

#endif
