/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SHIP_H
#define SHIP_H

struct ship_t {
	int xPos;
    int yPos;
    int Vel;
    int ang;
    int vis;
    BITMAP * sprite;
    int xSize;
    int ySize;
    int safe;
    };

void ship_init();
void ship_update();
void ship_shutdown();
void ship_draw();

extern int shieldPower;
extern struct ship_t ship;
extern BITMAP * shipSprite;


#endif
