/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: Circle functions
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

//#include "loadpng.h"
#include "main.h"
#include "system.h"
#include "thing.h"
//#include "tmake.h"
#include "draw.h"
//#include "level.h"
//#include "input.h"
//#include "shrap.h"
//#include "play.h"
//#include "file.h"
//#include "unpack.h"
//#include "menu.h"
#include "circ.h"

void doCircles()
{
  register int x;

  for(x=4; x<maxcirc; x++)
  {
    if(circ[x].life!=-1)
    {
      if(circ[x].life!=-2)
      {
        circ[x].life--;

        if(circ[x].life==0)
        {
          circ[x].life=-1;
          thing[circ[x].tOwner].circ[circ[x].tOwnerPos]=-1;
        }
      }

      circ[x].size+=circ[x].sizeSpd;

      if(circ[x].type==1)
        circ[x].rot+=circ[x].rotSpd;
    }
  }
}

void makeCircle(int tNum, int cNum)
{
  int x,y;

  if(cNum==0)
    return;

  if(circleDef[cNum].loaded==0)
    bombOut(32,cNum);

  newCircle:

  for(x=0; x<maxtcirc; x++)
  {
    if(thing[tNum].circ[x]==-1)
    {
      y=findEmptyC(); // get an empty circle
      if(y==0)        // no empty circles
        return;

      thing[tNum].circ[x]=y;

      circ[y].tOwner=tNum;
      circ[y].tOwnerPos=x;

      circ[y].type=circleDef[cNum].com[10];

      if(circleDef[cNum].com[0]==888 && thing[tNum].sprite!=888)
        circ[y].x=thing[tNum].w2;
      else
        circ[y].x=circleDef[cNum].com[0];

      if(circleDef[cNum].com[1]==888 && thing[tNum].sprite!=888)
        circ[y].y=thing[tNum].h2;
      else
        circ[y].y=circleDef[cNum].com[1];

      if(circ[y].type==0)      // circle
      {
        circ[y].oColor=circleDef[cNum].com[2];
        circ[y].fColor=circleDef[cNum].com[3];
        circ[y].size=circleDef[cNum].com[4];
      }
      if(circ[y].type==1)      // line
      {
        circ[y].x2=circleDef[cNum].com[2];
        circ[y].y2=circleDef[cNum].com[3];
        circ[y].fColor=circleDef[cNum].com[4];
        circ[y].rot=circleDef[cNum].com[11];
        circ[y].rotSpd=(float)(circleDef[cNum].com[12])/10;
      }

      if(circleDef[cNum].com[5]==888)
        circ[y].life=-2;
      else
        circ[y].life=circleDef[cNum].com[5];

      circ[y].vib=circleDef[cNum].com[6];
      circ[y].pos=circleDef[cNum].com[7];
      circ[y].sizeSpd=(float)(circleDef[cNum].com[8])/10;
      circ[y].trans=circleDef[cNum].com[31];

      if(circleDef[cNum].com[9]!=0 && circleDef[cNum].com[9]!=cNum)
      {
        cNum=circleDef[cNum].com[9];
        goto newCircle;
      }

      return;
    }
  }
}

int findEmptyC()
{
  int x;

  for(x=4; x<maxcirc; x++)
  {
    if(circ[x].life==-1)
      return x;
  }

  return 0;
}