#ifndef xop_h_draw
#define xop_h_draw

typedef struct sprStatObj
{
  int id,flash;
} sprStatObj;

typedef struct tileStatObj
{
  int origTile, origNext, origTlimit;
  int tile, timer, tlimit, next, trans;
} tileStatObj;

int sprID[maxsprite2];
struct tileStatObj tileStat[maxtile];

int colWhite,colBlack,colMagenta,colTrans,colGray,colLightGray,colBlue;

PALLETE pal;     // throwaway pallete
PALLETE palGame; // stores permanent pallete

RGB_MAP rgb_table;
COLOR_MAP trans_table;
COLOR_MAP flash_table_white;
COLOR_MAP flash_table_red;

BITMAP *buffer;
BITMAP *bgBuffer;
BITMAP *bgBuffer2;
BITMAP *bufStat;
BITMAP *cursor;
BITMAP *xopfont;
BITMAP *borderBmp;

BITMAP *sprPlay[32];
BITMAP *sprMain[maxsprite];
RLE_SPRITE *tile[maxtile];

void drawScreen();
void drawStatus();
void drawCircle(int tNum, int cNum);
void drawPlayer();
void drawShadows(int theBg);
void drawBackground(int theBg, BITMAP *theBmp);
void drawBgEffect(int theBg, BITMAP *destBmp);
void drawShrapnel(int shPos);
void drawTransform(int theTrans, int speed);
void drawTextCenter(BITMAP *targetBmp, char *text, int locY, int yOffset);
void drawText(BITMAP *targetBmp, char *text, int locX, int locY, int yOffset);
void displayMemory();
unsigned long displayMemoryAdd(unsigned int theMem);

#endif