/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: Functions to make things from scripts, explosions, and links
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

//#include "loadpng.h"
#include "main.h"
#include "system.h"
#include "thing.h"
#include "tmake.h"
//#include "draw.h"
#include "level.h"
//#include "input.h"
#include "shrap.h"
#include "play.h"
#include "file.h"
#include "unpack.h"
//#include "menu.h"
#include "circ.h"

void makeThing(int theScr)
{
  int x,y,z=0,x2,y2,z2,rot2,tLimit=0;
  float sx,sy,sz,srot;

  if(script[theScr].com[1]<=0 || script[theScr].com[1]>=maxdat2)
    return;

  // make thing number of times

  for(x=0; x<=script[theScr].com[10]; x++)
  {
    play.eCreated++;

    // position

    z2=script[theScr].com[4];
    if(z2>=888)
    {
      if(z2==888)           // random
        z2=(rand()%64)-32;
      if(z2==889)           // random lower
        z2=-64-(rand()%96);
      if(z2==890)           // random upper
        z2=64+(rand()%96);
      if(z2==891)           // random lower 2
        z2=-128-(rand()%120);
      if(z2==999)           // ground of bg 0 +2
        z2=bg[0].ground+2;
    }

    x2=script[theScr].com[2];
    if(x2==700)
      x2=(player.x+12)-actMain[thingAct[script[theScr].com[1]].com[THINGACT_INITACT]].w2;
    if(x2>=888)  // random
    {
      y=actMain[thingAct[script[theScr].com[1]].com[THINGACT_INITACT]].w2*2;

      if(x2==888)
      {
        x2=(rand()%400+z2)-z2/2;      // total screen
        z=400;
      }
      if(x2==889)
      {
        x2=(rand()%260)+80; // center screen
        z=340;
      }
      if(x2==890) // either left or right of screen
      {
        if(rand()%2==0)
        {
          x2=(rand()%80);      // left screen
          z=80;
        }
        else
        {
          x2=(rand()%80)+320;  // right screen
          z=400;
        }
      }
      if(x2==891)
      {
        x2=(rand()%200)+100; // narrow center screen
        z=300;
      }
      if(x2==892)
      {
        x2=(rand()%56);      // narrow left screen
        z=400;
      }
      if(x2==893)
      {
        x2=(rand()%56)+(344-y);  // narrow right screen
        z=500;
      }
      if(x2==894)
      {
        x2=(rand()%140)+120; // narrow center screen
        z=400;
      }

      if(x2+y>z)
        x2=z-y;
    }

    y2=script[theScr].com[3];
    if(y2>=888)  // random
    {
      if(y2==888)
        y2=rand()%300;       // total screen
      if(y2==889)
        y2=(rand()%160);     // upper screen
      if(y2==890)
        y2=(rand()%160)+160; // lower screen

      if(y2==891)            // top or side of the screen
      {
        if(rand()%6==0)
        {
          y2=rand()%26;

          if(rand()%2==0)
            x2=actMain[thingAct[script[theScr].com[1]].com[THINGACT_INITACT]].w2*-2;
          else
            x2=400+actMain[thingAct[script[theScr].com[1]].com[THINGACT_INITACT]].w2*2;
        }
        else
          y2=actMain[thingAct[script[theScr].com[1]].com[THINGACT_INITACT]].h2*-2;
      }

      y=actMain[thingAct[script[theScr].com[1]].com[THINGACT_INITACT]].h2*2;
      if(y2+y>300)
        y2=300-y;
    }

    // rotation

    rot2=script[theScr].com[17];
    if(rot2==888)
      rot2=rand()%256;
    if(rot2==889)
    {
      if(rand()%2==0)
        rot2=0;
      else
        rot2=64;
    }

     // speed

    sx=(float)(script[theScr].com[5])/10;
    sy=(float)(script[theScr].com[6])/10;
    sz=(float)(script[theScr].com[7])/10;
    srot=(float)(script[theScr].com[12])/10;

    if(script[theScr].com[13]!=0)
    {
      y=script[theScr].com[13];
      if(y>0)
        sx+=(float)(rand()%y)/10;
      else
        sx-=(float)(rand()%y)/10;
    }
    if(script[theScr].com[14]!=0)
    {
      y=script[theScr].com[14];
      if(y>0)
        sy+=(float)(rand()%y)/10;
      else
        sy-=(float)(rand()%y)/10;
    }
    if(script[theScr].com[15]!=0)
    {
      y=script[theScr].com[15];
      if(y>0)
        sz+=(float)(rand()%y)/10;
      else
        sz-=(float)(rand()%y)/10;
    }
    if(script[theScr].com[23]!=0)
    {
      y=script[theScr].com[23];
      if(y>0)
        srot+=(float)(rand()%y)/10;
      else
        srot-=(float)(rand()%y)/10;
    }

    // make the thing

    y=findEmptyTOffset(tLimit);
    tLimit=y;

    initThing(y, 
    x2+(script[theScr].com[18]*x),y2+(script[theScr].com[19]*x),z2+(script[theScr].com[30]*x),
    sx,sy,sz,script[theScr].com[8],
    script[theScr].com[1],0,thingAct[script[theScr].com[1]].com[THINGACT_INITACT],script[theScr].com[9]);

    z=thing[y].type;

    // misc stuff

    thing[y].rot=rot2;
    thing[y].srot=srot;
    thing[y].deathscr=script[theScr].com[11];
    thing[y].sType=script[theScr].com[20];
    thing[y].dirRot=script[theScr].com[24];
    thing[y].range=script[theScr].com[26];
    thing[y].rangeAMT=script[theScr].com[25];
    thing[y].tid=script[theScr].com[29];

    if(thing[y].shield>0.5)
    {
      thing[y].shield+=shieldAdd;
      thing[y].sMax+=shieldAdd;

      if(thing[y].shield<=0 && shieldAdd<0)
      {
        thing[y].shield=0.05;
        thing[y].sMax=0.05;
      }
    }

    if(script[theScr].com[28]>0)
      copyActT(y,script[theScr].com[28]);

    // shot type

    if(thing[y].sType!=0)
    {
      thing[y].sTimer=0;
      thing[y].sTimerLimit=script[theScr].com[22];
      if(thing[y].sTimerLimit==999)
        thing[y].sTimerLimit=64000;
      thing[y].sNext=thing[y].sType;
      thing[y].sCutoff=0;
    }
    thing[y].sWait=script[theScr].com[21];
    if(thing[y].sWait==777)
      thing[y].sWait=rand()%128;

    // automovement

    if(script[theScr].com[16]!=0)
      copyAMT(y,script[theScr].com[16]);

    // circles

    if(thingDef[z].com[THINGDEF_EC1]!=0)
      makeCircle(y,thingDef[z].com[THINGDEF_EC1]);

    // make linked things

    thing[y].tLinkNum=thingDef[z].com[THINGDEF_LINKTYPE];
    if(thing[y].tLinkNum!=0)
      makeLink(y,thing[y].tLinkNum);

    thing[y].tLinkNumDam=thingDef[z].com[THINGDEF_DAMLINK];
  }
}

void makeExpDef(int tNum, int eNum)
{
  int x,y,tX,tY,tZ;

  if(eNum<=0 || eNum>=maxdat)
    return;

  if(expDef[eNum].loaded==0)
    bombOut(32,eNum);

  newExp:

  x=thingAct[expDef[eNum].com[15]].com[THINGACT_INITACT];

  if(expDef[eNum].com[0]==888)      // make center
    tX=((thing[tNum].x+thing[tNum].w2)-(actMain[x].w2+actMain[x].offX))-expDef[eNum].com[3]/2;
  else if(expDef[eNum].com[0]==999) // make random
    tX=(thing[tNum].x+thing[tNum].hrX1+(rand()%thing[tNum].hrX3))-(actMain[x].w2+actMain[x].offX);
  else
  {
    if(thing[tNum].dir==0)
      tX=thing[tNum].x+expDef[eNum].com[0];
    else
      tX=thing[tNum].x+((thing[tNum].w2*2)-(expDef[eNum].com[0]+actMain[x].hrX2));
  }

  if(expDef[eNum].com[1]==888)      // make center
    tY=((thing[tNum].y+thing[tNum].h2)-(actMain[x].h2+actMain[x].offY))-expDef[eNum].com[4]/2;
  else if(expDef[eNum].com[1]==999) // make random
    tY=(thing[tNum].y+thing[tNum].hrY1+(rand()%thing[tNum].hrY3))-(actMain[x].h2+actMain[x].offY);
  else
    tY=thing[tNum].y+expDef[eNum].com[1];

  if(expDef[eNum].com[2]==888)
    tZ=0;
  else
    tZ=thing[tNum].z+expDef[eNum].com[2];

  if(expDef[eNum].com[17]==0) // immediate explosion
    makeExp(tX,tY,tZ,eNum);
  else
  {
    for(y=0; y<maxtimer; y++) // delayed explosion, make timer for it
    {
      if(timer[y].timer==-1)
      {
        timer[y].timer=expDef[eNum].com[17];
        timer[y].scriptAct=eNum+900;

        if(expDef[eNum].com[20]==1) // make thing lookup
        {
          timer[y].tLookup=tNum;
        }
        else
        {
          timer[y].x=tX;
          timer[y].y=tY;
          timer[y].z=tZ;
          timer[y].tLookup=-1;
        }

        goto madeTimer;
      }
    }
    madeTimer:;
  }

  if(expDef[eNum].com[21]!=0) // if there is a next exp, make it
  {
    eNum=expDef[eNum].com[21];
    goto newExp;
  }
}

void makeExp(int tX, int tY, int tZ, int eNum)
{
  int x,y,z,expAdd,tLimit=0;
  float x2,y2,z2,sx,sy,sz,srot,expSpdAdd;

  if(eNum<=0 || eNum>=maxdat)
    return;

  if(expDef[eNum].loaded==0)
    bombOut(32,eNum);

  // alternate random explosion

  if(expDef[eNum].com[23]!=0 && rand()%2==1)
    eNum=expDef[eNum].com[23];

  // shrapnel

  if(expDef[eNum].com[22]!=0)
    makeShrapDef(tX,tY,tZ,expDef[eNum].com[22],0);

  // add extra things?

  if(expDef[eNum].com[24]==1 && gOpt.expMode>0)
  {
    expAdd=(gOpt.expMode*2)+(gOpt.expMode/2);
    expSpdAdd=(gOpt.expMode+1)/4;
  }
  else
  {
    expAdd=0;
    expSpdAdd=0;
  }

  // make thing number of times

  for(x=0; x<=expDef[eNum].com[16]+expAdd; x++)
  {
    // position

    x2=tX;
    y2=tY;
    z2=tZ;

    if(expDef[eNum].com[3]!=0)
      x2+=rand()%expDef[eNum].com[3];
    if(expDef[eNum].com[4]!=0)
      y2+=rand()%expDef[eNum].com[4];
    if(expDef[eNum].com[5]!=0)
      z2+=rand()%expDef[eNum].com[5];

    // speed

    sx=(float)(expDef[eNum].com[6])/10;
    sy=(float)(expDef[eNum].com[7])/10;
    sz=(float)(expDef[eNum].com[8])/10;
    srot=(float)(expDef[eNum].com[13])/10;

    if(expSpdAdd!=0)
    {
      sx-=expSpdAdd;
      sy-=expSpdAdd;
      sz-=expSpdAdd;

      sx+=(float)(rand()%gOpt.expMode)/2;
      sy+=(float)(rand()%gOpt.expMode)/2;
      sz+=(float)(rand()%gOpt.expMode)/2;
    }

    if(expDef[eNum].com[9]!=0)
    {
      y=expDef[eNum].com[9];
      if(y>0)
        sx+=(float)(rand()%y)/10;
      else
        sx-=(float)(rand()%y)/10;
    }
    if(expDef[eNum].com[10]!=0)
    {
      y=expDef[eNum].com[10];
      if(y>0)
        sy+=(float)(rand()%(y*10))/100;
      else
        sy-=(float)(rand()%(y*10))/100;
    }

    if(expDef[eNum].com[11]!=0)
    {
      y=expDef[eNum].com[11];
      if(y>0)
        sz+=(float)(rand()%y)/10;
      else
        sz-=(float)(rand()%y)/10;
    }
    if(expDef[eNum].com[14]!=0)
    {
      y=expDef[eNum].com[14];
      if(y>0)
        srot+=(float)(rand()%(y*10))/100;
      else
        srot-=(float)(rand()%(y*10))/100;
    }

    z=expDef[eNum].com[15];
    if(z==play.dalType)
      if(rand()%24==12)
        z=play.dalSilvType;

    y=findEmptyTOffset(tLimit);
    tLimit=y;
    if(y==maxthing-1)
      return;
    
    initThing(y,x2,y2,z2,sx,sy,sz,0,z,0,thingAct[z].com[THINGACT_INITACT],1);

    // gravity

    thing[y].gx=(float)(expDef[eNum].com[28])/1000;
    thing[y].gy=(float)(expDef[eNum].com[29])/1000;
    //thing[y].gz=(float)(expDef[eNum].com[30])/1000;

    if(expDef[eNum].com[19]==1)
      thing[y].sy+=play.speed;

    thing[y].rot=expDef[eNum].com[12];
    if(thing[y].rot==888)
      thing[y].rot=rand()%256;
    thing[y].srot=srot;

    if(expDef[eNum].com[25]!=0)
      copyActT(y,expDef[eNum].com[25]);

    if(expDef[eNum].com[26]!=0)
    {
      copyAMT(y,expDef[eNum].com[26]);      // amt

      if(expDef[eNum].com[23]!=0 && thing[y].amTimerLimit!=666)
        thing[y].amTimerLimit+=expDef[eNum].com[23];
    }

    if(thingDef[thing[y].type].com[THINGDEF_EC1]!=0)
      makeCircle(y,thingDef[thing[y].type].com[THINGDEF_EC1]);    // circles
    if(expDef[eNum].com[27]!=0)
      makeCircle(y,expDef[eNum].com[27]);

    if(expDef[eNum].com[18]>0 && thing[y].tlimit!=666)  // random add to tlimit
      thing[y].tlimit+=rand()%expDef[eNum].com[18];

    thing[y].dTimer=expDef[eNum].com[31];  // time to live
  }
}

void makeLink(int tNum, int lNum)
{
  int x,y,z,oldLink=0;
  float x2,y2,z2,sx,sy,sz,srot;

  if(linkDef[lNum].loaded==0)
    bombOut(32,lNum);

  if(thing[tNum].stat==-1)
    return;

  if(linkDef[lNum].com[8]==1)
  {
    if(thing[tNum].shield<=0 || thing[tNum].stat==1)
      return;
  }

  thing[tNum].tz=linkDef[lNum].com[18]+1;

  newLink:

  // make thing number of times

  for(x=0; x<=linkDef[lNum].com[18]; x++)
  {
    // position

    x2=linkDef[lNum].com[0]+(linkDef[lNum].com[30]*x);
    y2=linkDef[lNum].com[1];//+(linkDef[lNum].com[31]*x);
    z2=linkDef[lNum].com[2]+(linkDef[lNum].com[31]*x);

    if(linkDef[lNum].com[5]==1)
    {
      rotPos(x2,y2,thing[tNum].rot);
      x2=rx; y2=ry;
    }

    x2+=thing[tNum].x;
    y2+=thing[tNum].y;
    z2+=thing[tNum].z;

    // random add

    z=actMain[thingAct[linkDef[lNum].com[12]].com[THINGACT_INITACT]].w2/2;
    y=linkDef[lNum].com[24];
    if(y!=0)
    {
      if(y==888)
      {
        x2+=(thing[tNum].hrX1+(rand()%(thing[tNum].hrX2-thing[tNum].hrX1)))-z;
      }
      else
        x2+=rand()%y;
    }
    y=linkDef[lNum].com[25];
    if(y!=0)
    {
      if(y==888)
        y2+=(thing[tNum].hrY1+(rand()%(thing[tNum].hrY2-thing[tNum].hrY1)))-z;
      else
        y2+=rand()%y;
    }
    y=linkDef[lNum].com[26];
    if(y!=0)
    {
      if(y==888)
        z2+=rand()%thing[tNum].hrZ2;
      else
        z2+=rand()%y;
    }

    // speed

    sx=(float)(linkDef[lNum].com[3])/10;
    sy=(float)(linkDef[lNum].com[4])/10;
    sz=0; //sz=(float)(linkDef[lNum].com[5])/10;
    srot=(float)(linkDef[lNum].com[10])/10;

    y=linkDef[lNum].com[6];
    if(y!=0)
    {
      if(y>0)
        sx+=(float)(rand()%y)/10;
      else
        sx-=(float)(rand()%y)/10;
    }
    y=linkDef[lNum].com[7];
    if(y!=0)
    {
      if(y>0)
        sy+=(float)(rand()%y)/10;
      else
        sy-=(float)(rand()%y)/10;
    }
    /*y=linkDef[lNum].com[8];
    if(y!=0)
    {
      if(y>0)
        sz+=(float)(rand()%y)/10;
      else
        sz-=(float)(rand()%y)/10;
    }
    y=linkDef[lNum].com[11];
    if(y!=0)
    {
      if(y>0)
        srot+=(float)(rand()%y)/10;
      else
        srot-=(float)(rand()%y)/10;
    }*/

    y=findEmptyTOffset(tNum);

    initThing(y,
    x2,y2,z2,sx,sy,sz,linkDef[lNum].com[13],
    linkDef[lNum].com[12],0,thingAct[linkDef[lNum].com[12]].com[THINGACT_INITACT],linkDef[lNum].com[14]);

    // misc stuff

    thing[y].tLink=tNum;
    thing[y].tLinkType=linkDef[lNum].com[28];
    thing[y].tLinkSrc=lNum;
    thing[y].tLinkPos=x;

    thing[y].rot=linkDef[lNum].com[9];
    if(thing[y].rot==888)
      thing[y].rot=rand()%256;

    thing[y].deathscr=linkDef[lNum].com[16];
    thing[y].srot=srot;
    thing[y].sType=linkDef[lNum].com[19];
    thing[y].tid=linkDef[lNum].com[29];

    if(linkDef[lNum].com[23]==888)
      thing[y].dirRot=1;

    if(linkDef[lNum].com[11]!=0)
      copyActT(y,linkDef[lNum].com[11]);

    if(thing[y].shield>0.5)
    {
      thing[y].shield+=shieldAdd;
      thing[y].sMax+=shieldAdd;

      if(thing[y].shield<=0 && shieldAdd<0)
      {
        thing[y].shield=0.05;
        thing[y].sMax=0.05;
      }
    }

    // shot type

    if(thing[y].sType!=0)
    {
      thing[y].sTimer=0;
      thing[y].sTimerLimit=linkDef[lNum].com[21];
      if(thing[y].sTimerLimit==999)
        thing[y].sTimerLimit=64000;
      thing[y].sNext=thing[y].sType;
      thing[y].sCutoff=0;
    }
    thing[y].sWait=linkDef[lNum].com[20];

    // automovement

    if(linkDef[lNum].com[15]!=0)
      copyAMT(y,linkDef[lNum].com[15]);

    // circles

    if(thingDef[thing[y].type].com[20]!=0)
      makeCircle(y,thingDef[thing[y].type].com[20]);

    if(linkDef[lNum].com[27]>0 && thing[y].tlimit!=666)
      thing[y].tlimit+=rand()%linkDef[lNum].com[27];

    // link type

    if(thing[y].tLinkType==0 || thing[y].tLinkType==1) // fixed
    {
      thing[y].sx=thing[tNum].sx;
      thing[y].sy=thing[tNum].sy;
      thing[y].sz=thing[tNum].sz;
    }

    if(thing[y].tLinkType==2) // semi-fixed
    {
      thing[y].tx=thing[tNum].x;
      thing[y].ty=thing[tNum].y;
      thing[y].tz=thing[tNum].z;
    }

    if(thing[y].tLinkType==3) // free
    {
      
    }

    if(thing[y].tLinkType==4 || thing[y].tLinkType==6 || thing[y].tLinkType==8) // chain
    {
      if(x==0) // if this is the first link
      {
        x2=0; // counter
        for(z=tNum+1; z<maxthing; z++) // we have to find what the final link will be
        {                         // by cycling through the thing array and counting unused things
          if(thing[z].stat==-1)
          {
            oldLink=z;

            x2++;
            if(x2==linkDef[lNum].com[18]+1)
              goto gotFinalLink;
          }
        }
        bombOut(29,0); // if we didn't get the final link, bomb out
      }
      gotFinalLink:;

      thing[y].tLink2=oldLink;
    }

    if(thing[y].tLinkType==5) // snake
    {
      thing[y].tLink2=findEmptyTOffset(tNum);
    }

    if(thing[y].tLinkType==6 || thing[y].tLinkType==8) // dissipating snake
    {
      thing[y].tLink3=findEmptyTOffset(tNum);
    }

    // links on links (whee!)

    thing[y].tLinkNumDam=thingDef[thing[y].type].com[THINGDEF_DAMLINK];

    z=thingDef[thing[y].type].com[THINGDEF_LINKTYPE];
    thing[y].tLinkNum=z;
    if(z!=0 && z!=lNum && z!=linkDef[lNum].com[22])
      makeLink(y,z);
  }

  if(linkDef[lNum].com[22]==0 && linkDef[lNum].com[28]>=4 && linkDef[lNum].com[28]!=7) // if this is a chain/snake link and there isn't any next link, bombout
    bombOut(31,0);

  if(linkDef[lNum].com[22]!=0) // if there is a next link, make it
  {
    lNum=linkDef[lNum].com[22];
    goto newLink;
  }
}