/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: XOP Packfile functions
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

//#include "loadpng.h"
#include "main.h"
#include "system.h"
//#include "thing.h"
//#include "tmake.h"
//#include "draw.h"
//#include "level.h"
//#include "input.h"
//#include "shrap.h"
//#include "play.h"
#include "file.h"
#include "unpack.h"
//#include "menu.h"

void unpackFile(char *fNameFind, char *fNameOut)
{
  int x,y;
  unsigned char temp[4];
  FILE *outFile;

  if(!inFile)
    return;

  for(x=0; x<lSize; x++)
  {
    if(strcmp(fNameFind,fNameList[x])==0) // if it's the file we're looking for
    {
      if((outFile=fopen(fNameOut, "wb"))==NULL)
      {
        fclose(inFile);
        bombOut(24,0);
      }

      fseek(inFile,fNamePos[x],SEEK_SET);  // go to the prerecorded offset of this file entry

      for(;;)      // take data and put it into output file
      {
        temp[0]=getc(inFile);

        if(feof(inFile))
          goto dataEnd;

        if(temp[0]==123)
        {
          temp[1]=getc(inFile); temp[2]=getc(inFile); temp[3]=getc(inFile);

          if(temp[1]==45 && temp[2]==62 && temp[3]==58) // end of this file
            goto dataEnd;
          else
          {
            for(y=0; y<4; y++)
              fputc(temp[y],outFile);
          }
        }
        else
          fputc(temp[0],outFile);
      }

      dataEnd:

      fclose(outFile);
      return;
    }
  }

  fclose(inFile); // couldn't find the file
  bombOutText(0,fNameFind);
}

void seekFile(char *fNameFind)
{
  int x;

  if(!inFile)
    return;

  for(x=0; x<lSize; x++)
  {
    if(strcmp(fNameFind,fNameList[x])==0) // if it's the file we're looking for
    {
      fseek(inFile,fNamePos[x],SEEK_SET);
      return;
    }
  }

  fclose(inFile); // couldn't find the file
  bombOutText(0,fNameFind);
  return;
}

int verifyFile(char *fNameFind)
{
  int x;

  if(!inFile)
    return -1;

  for(x=0; x<lSize; x++)
  {
    if(strcmp(fNameFind,fNameList[x])==0) // if it's the file we're looking for
    {
      fseek(inFile,fNamePos[x],SEEK_SET);
      return 0;
    }
  }

  return -1;
}

void openPackfile(char *datName)
{
  int x;
  unsigned char temp[4];
  char fName[32];
  long fPos;

  #ifdef xop_fileout
  FILE *outFile;
  outFile=fopen("flist.txt","w");
  #endif

  if((inFile=fopen(datName, "rb"))==NULL)
    bombOutText(2,datName);

  // find where every file in the datafile is

  lSize=0;

  while(!feof(inFile))
  {
    temp[0]=getc(inFile);

    if(temp[0]==123 && lSize<2048)
    {
      fPos=ftell(inFile);
      temp[1]=getc(inFile); temp[2]=getc(inFile); temp[3]=getc(inFile);

      if(temp[1]==45 && temp[2]==62 && temp[3]==58) // if this is a correct file name pointer {->:
      {
        for(x=0; x<24; x++)
          fName[x]=NULL;

        x=0;
        while(!feof(inFile))     // get file name
        {
          temp[0]=getc(inFile);
          if(temp[0]==125)        // end of file name
            break;
          fName[x]=temp[0];
          x++;
        }

        #ifdef xop_fileout
        fprintf(outFile,"%s, %i\n",fName,(unsigned int)ftell(inFile));
        #endif

        if(strlen(fName)>=24)
          bombOutText(4,fName);

        sprintf(fNameList[lSize],"%s",fName);
        fNamePos[lSize]=ftell(inFile);
        lSize++;
      }
      else                       // if not a correct file name, go back
      {
        fseek(inFile,fPos,SEEK_SET);
      }
    }
  }

  #ifdef xop_fileout
  fclose(outFile);
  #endif
  rewind(inFile);
}

void openPackfilePMODE(char *datName) // only opens the file, doesn't read in file list
{
  if((inFile=fopen(datName, "rb"))==NULL)
    bombOutText(2,datName);
}

void closePackfile()
{
  if(inFile)
  {
    fclose(inFile);
    inFile=NULL;
  }
}