/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef DISPLAY_H
#define DISPLAY_H

void display_init();
void display_update();
void display_shutdown();
void takeshot();
char * findfile(char * s);

extern BITMAP *field, *field_bg, * screen_img, * status;

extern DATAFILE * fontDat;
extern PALETTE masterpal;


#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480
#define STATUS_HEIGHT 40
#define FIELD_WIDTH SCREEN_WIDTH
#define FIELD_HEIGHT SCREEN_HEIGHT - STATUS_HEIGHT

#endif
