/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef GAME_H
#define GAME_H

void abnormal_exit(int code);
void game_init();
void game_run();
void game_shutdown();
void game_miniframe();	/* run a frame...minus the ship_update...
						 * right now, this is only used when the player dies
                         * and we pause for a while, pdating everything but ship
                         * while the explosion goes off...
                         */

void run_once();	/* call to run through one complete game...this is calld by
					 * the title module.
                     */

extern int end_game;
extern int pauseGame;

#endif

