/*  Rasteroids 0.01 - a free asteroids clone
    Copyright (C) 2000  Brian Luczkiewicz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <allegro.h>
#include <stdio.h>
#include <time.h>
#include "title.h"
#include "skin.h"

void init()
{
	allegro_init();
    install_keyboard();
    install_mouse();
    install_timer();
    srand(clock());
}

void shutdown() /* if you call allegro_exit() here, linux segfaults do it's not there now */
{
}

int main(int argc, char **argv)
{

#ifdef __BEOS__
int counti;
char datapath[256];
for (counti=strlen(argv[0]) ; argv[0][counti]!='/' ; counti--);
strncpy(datapath, argv[0], counti);
chdir(datapath);
#endif

	skinName = argv[1];
    init();
    title();
    shutdown();
    return 0;
}

#ifdef __LINUX__
END_OF_MAIN();
#endif
