/*
    This file is part of "UFO 2000" aka "X-COM: Gladiators"
                         http://ufo2000.sourceforge.net/
    Copyright (C) 2000-2001  Alexander Ivanov aka Sanami <sanami@chat.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef PCK_H
#define PCK_H
#include <allegro.h>

#define MAXNUM 500

class PCK {
protected:
	BITMAP **m_bmp;
	int *m_bmpofs;

	static unsigned char m_tbb[0xFFFF];
	static unsigned short m_tbs[0xFFF];
	static char m_fname[0x100];
public:
	int imgnum;

	PCK(char *pckfname);
	~PCK();

	void loadpck(char *pckfname);
	void showpck(int num);
	void showpck(int num, int xx, int yy);
	void drawpck(int num, BITMAP *dest, int y);
	int add_image(char *fname);
};

#endif
