#ifndef xop_h_file
#define xop_h_file

void readActObj(char *path, actObj theAct[], BITMAP *theSpr[], int useID); // reads .act files
void readDatFile(char *path, datObj theDat[], int error);                  // reads .def & .scr files
void loadImage(char *path, int offset, int error);       // reads sprite.dat file
void loadTile(char *path, int error);                // reads level.til files
void loadSound(char *path, int error);                  // reads sound.dat
void saveOptions();
void loadOptions();

void saveHiscore();
void loadHiscore();

/*__inline*/ int getNum(FILE *theFile);       // gets a [000 number
/*__inline*/ int getNumPos(FILE *theFile);    // gets a [+000 number
/*__inline*/ int getNumPosDat(FILE *theFile);    // gets a [+000 number, doesn't read next char
/*__inline*/ void putNum(int theNum, FILE *theFile); // puts a [000 number

#endif