#ifndef xop_h_level
#define xop_h_level

typedef struct effectObj
{
  int eVar[8];
  int effect;
} effectObj;

typedef struct bgObj
{
  float speed,scoff,hoff,hspeed,noShadow;
  int ground,gDepth,stat,tsize;

  int mapW,mapH,mapHt,mapWp,toff;

  struct effectObj e[4];

  unsigned char *script;
  unsigned char *map;
} bgObj;

struct bgObj bg[maxbg];

void doBackground();
void doTiles();
void doTimer();
void doMisc();
void makeTimer(int iTimer, int iScriptAct, int itLookup);
void loadLevel(int lvlnum);
void loadBgMap(int theBg, char *path);
void runScript(int theScript);

#endif