/* loadpng.h */
#ifndef _included_loadpng_h_
#define _included_loadpng_h_

#ifdef __cplusplus
extern "C" {
#endif 

/* Overkill :-) */    
#define LOADPNG_VERSION		0
#define LOADPNG_SUBVERSION	4
#define LOADPNG_VERSIONSTR	"0.4"

    
/* Screen gamma value.  Default is -1, which chooses either:
 *  1) Get environment variable SCREEN_GAMMA
 *  2) Use the default of 2.2
 */
extern double _png_screen_gamma;

    
/* Choose zlib compression level for saving file.
 * Default is Z_BEST_COMPRESSION.
 */
extern int _png_compression_level;

void register_png_file_type(void);
BITMAP *load_png(AL_CONST char *filename, RGB *pal);
BITMAP *load_png_file(FILE *fp, RGB *pal);
int save_png(AL_CONST char *filename, BITMAP *bmp, AL_CONST RGB *pal);

BITMAP *_fixup_loaded_bitmap2(BITMAP *bmp, PALETTE pal, int bpp);

#ifdef __cplusplus
}
#endif

#endif /* _included_loadpng_h */
