/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: All game menus and intermission screens
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

//#include "loadpng.h"
#include "main.h"
#include "system.h"
#include "thing.h"
#include "tmake.h"
#include "draw.h"
#include "level.h"
#include "input.h"
#include "shrap.h"
#include "play.h"
#include "file.h"
//#include "unpack.h"
#include "menu.h"
#include "circ.h"

void mainMenuInit()
{
  rectfill(screen,sXoff+1,sYoff-19,sXoff+276,sYoff-2,0); // clear status

  if(pauseStat==1)
  {
    pauseStat=0;
    set_mod_volume(gOpt.musicVol);
  }

  if(player.dir<=-320) // if called from a gameover
    hiScores(1);
  else
  {
    openMOD(getPath("mod/menu.xm"));
    mainMenu();
  }
}

void mainMenu() // uses counter
{
  int x,y,mX,mY,mB,offX,offY,offX2,offY2,offYnext,hiBtn,inputDown=0;
  int colList[16];
  static int mPos=-1;

  clear(buffer);
  clear(bgBuffer);
  blit(sprPlay[19],screen,0,0,sXoff,sYoff,280,300);
  rectfill(screen,sXoff+1,sYoff-19,sXoff+276,sYoff-2,0); // clear status

  colList[0]=0;
  colList[1]=17;
  colList[2]=18;
  colList[3]=202;
  colList[4]=180;
  colList[5]=236;
  colList[6]=108;
  colList[7]=5;
  colList[8]=35;
  colList[9]=13;
  colList[10]=60;
  colList[11]=84;
  colList[12]=15;

  while(mouse_b & 1 || key[KEY_ESC] || key[KEY_ENTER] || pInput[INPUT_A1]) { updateInput(); }

  resetCounter();
  for(;;)
  {
    while(sCount>0)
    {
      doStdInput();

      mX=mouse_x+15;
      mY=mouse_y+15;
      mB=mouse_b & 1;
      offX=88 +sXoff;
      offY=139+sYoff;
      offYnext=25;
      offX2=105;
      offY2=21;

      hiBtn=-1;

      if(mPos==-1)
      {
        mPos=0;
        if(palOk==0)
          position_mouse(offX-11,(offY-3)+(mPos*(offYnext-1)));
      }

      if((pInput[INPUT_D] || pInput[INPUT_U]) && inputDown==0)
      {
        if(pInput[INPUT_D])
        {
          mPos++;
          if(mPos==6)
            mPos=0;
        }

        if(pInput[INPUT_U])
        {
          mPos--;
          if(mPos==-1)
            mPos=5;
        }

        position_mouse(offX-11,(offY-3)+(mPos*offYnext));
        play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);

        inputDown=1;
      }

      if(!pInput[INPUT_D] && !pInput[INPUT_U])
        inputDown=0;

      if(mX>offX && mX<offX+offX2 && mY>offY && mY<offY+offY2) // Start Game
      {
        hiBtn=0;

        if(mB || pInput[INPUT_A1])
        {
          play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);

          gOpt.gameMode=0;
          weaponSelect();
          initGame();
          loadLevel(gOpt.lOrder[gOpt.lComp]);
          gameLoop();
        }
      }
      offY+=offYnext;

      if(mX>offX && mX<offX+offX2 && mY>offY && mY<offY+offY2) // Score attack
      {
        hiBtn=1;

        if(mB || pInput[INPUT_A1])
        {
          play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);
          scoreAttack(0);
        }
      }
      offY+=offYnext;

      if(mX>offX && mX<offX+offX2 && mY>offY && mY<offY+offY2) // Options
      {
        hiBtn=2;

        if(mB || pInput[INPUT_A1])
        {
          if(pInput[INPUT_A1])
            position_mouse(sXoff-8,sYoff-8);

          play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);
          options();
        }
      }
      offY+=offYnext;

      if(mX>offX && mX<offX+offX2 && mY>offY && mY<offY+offY2) // Scores
      {
        hiBtn=3;

        if(mB || pInput[INPUT_A1])
        {
          play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);
          hiScores(0);
        }
      }
      offY+=offYnext;

      if(mX>offX && mX<offX+offX2 && mY>offY && mY<offY+offY2) // Show credits
      {
        hiBtn=4;

        if(mB || pInput[INPUT_A1])
        {
          play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);
          credits();
        }
      }
      offY+=offYnext;

      if((mX>offX && mX<offX+offX2 && mY>offY && mY<offY+offY2) || key[KEY_ESC]) // Quit
      {
        hiBtn=5;

        if(mB || pInput[INPUT_A1] || key[KEY_ESC])
        {
          play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);
          drawTransform(2,6);
          doQuit();
        }
      }

      waitCounter();
    }

    if(sCountDrawOk==1)
    {
      blit(sprPlay[19],buffer,0,0,0,0,280,300);

      offY=139+sYoff;

      for(x=0; x<6; x++)
      {
        if(hiBtn==x)
          rect(buffer,(offX-2)-sXoff,(offY-2)-sYoff,(offX+offX2+2)-sXoff,(offY+offY2+2)-sYoff,colWhite);

        offY+=offYnext;
      }

      // background effect

      setTrans(1);

      for(y=0; y<164; y++)
      {
        for(x=0; x<96; x++)
        {
          if(rand()%8<4)
            putpixel(bgBuffer,x,y,colList[rand()%12]);
        }
      }

      setTrans(0);

      // left panel

      for(y=183; y<300; y++)
      {
        for(x=0; x<66; x++)
        {
          if(getpixel(buffer,x,y)==colTrans)
          {
            if(x%2==0)
              putpixel(buffer,x,y,0);
            else
              putpixel(buffer,x,y,getpixel(bgBuffer,x,y-141));
          }
        }
      }

      // right panel

      for(y=183; y<300; y++)
      {
        for(x=223; x<280; x++)
        {
          if(getpixel(buffer,x,y)==colTrans)
          {
            if(x%2==0)
              putpixel(buffer,x,y,0);
            else
              putpixel(buffer,x,y,getpixel(bgBuffer,x-200,y-141));
          }
        }
      }

      // mouse

      draw_sprite(buffer,cursor,mouse_x-sXoff,mouse_y-sYoff);

      blitToScreen();

      sCountDrawOk=0;
    }
  }
}

void weaponSelect() // uses counter
{
  int x,curSc,flash=0,pMoveTimer=0;
  float move,tileX,tileY;
  char scText[8][128];
  char path=0;
  struct tObj thingsc[8];
  BITMAP *mImage,*mImage2,*tileXbmp,*tileYbmp,*scTile[maxscspr];

  clear(buffer);

  for(x=0; x<maxscspr; x++)
    scTile[x]=NULL;

  // weapon data

  sprintf(scText[0],"Bots\n\nPower  *\nRange  **\nWeight **\nTarget Multi\nType   Impact\nDAL    2000");
  sprintf(scText[1],"Velocity C.\n\nPower  ***\nRange  *\nWeight *\nTarget Single\nType   Pierce\nDAL    3000");
  sprintf(scText[2],"Spread Laser\n\nPower  *\nRange  ***\nWeight ***\nTarget Multi\nType   Impact\nDAL    2000");
  sprintf(scText[3],"Missles\n\nPower  **\nRange  *\nWeight *\nTarget Single\nType   Impact\nDAL    3000");
  sprintf(scText[4],"Implosion\n\nPower  ***\nRange  **\nWeight **\nTarget Single\nType   Pierce\nDAL    4000");
  sprintf(scText[5],"Plasma Stream\n\nPower  **\nRange  ***\nWeight ***\nTarget Multi\nType   Pierce\nDAL    3000");

  // read images

  mImage=readPNG(getPath("png/system/menu02.png"));
  mImage2=readPNG(getPath("png/system/menu02b.png"));
  tileXbmp=readPNG(getPath("png/system/menu02t2.png"));
  tileYbmp=readPNG(getPath("png/system/menu02t1.png"));

  scTile[0]=readPNG(getPath("png/system/sc01.png"));
  scTile[1]=readPNG(getPath("png/system/sc02.png"));
  scTile[2]=readPNG(getPath("png/system/sc03.png"));
  scTile[3]=readPNG(getPath("png/system/sc04.png"));
  scTile[4]=readPNG(getPath("png/system/sc05.png"));
  scTile[5]=readPNG(getPath("png/system/sc06.png"));
  scTile[6]=readPNG(getPath("png/system/scdone01.png"));

  // set up icons

  for(x=0; x<6; x++)
  {
    thingsc[x].sprite=5-x;
    thingsc[x].stat=0;

    thingsc[x].x=90;
    thingsc[x].y=111;
    thingsc[x].z=0;
  }

  thingsc[0].rot=42; thingsc[1].rot=84; thingsc[2].rot=126;
  thingsc[3].rot=168; thingsc[4].rot=210; thingsc[5].rot=0;

  gOpt.lComp=0;
  curSc=5;
  move=0;
  tileX=0;
  tileY=0;

  // do stuff for weapon preview

  for(x=0; x<maxthing; x++)
  {
    thing[x].stat=-1;
    thing[x].sprite=0;
  }
  for(x=0; x<maxbg; x++)
    bg[x].stat=-1;
  for(x=0; x<maxtimer; x++)
    timer[x].timer=-1;
  for(x=0; x<maxshrap; x++)
    sh[x].type=-1;
  for(x=4; x<maxcirc; x++)
    circ[x].life=-1;
  for(x=0; x<4; x++)
    rs[x].stat=-1;
  for(x=0; x<maxsound; x++)
    sndPlay[x]=1;

  introCount=600;
  introSign=0;
  pauseStat=0;
  gCount=0;
  gStat=0;
  bgPosX=0;
  bgCount=0;

  player.x=24;
  player.y=150-34;
  player.z=0;
  player.stat=0;
  player.type=0;
  player.dir=0;
  play.invunStat=0;
  play.lostLife=1;
  play.speed=0;
  play.health=999;

  play.shotTimer=0;
  play.shotTimerReload=7;
  play.shotNum=0;
  play.shotMax=8;

  for(x=0; x<8; x++)
    play.wpn[x].level=1;

  play.curWpn=0;
  createWeapon(0);

  copyActP(1);

  while(pInput[INPUT_A1]) { updateInput(); } // wait for input to end

  // muzak

  //openMOD(getPath("mod/wselect.xm"));

  resetCounter();
  for(;;)
  {
    while(sCount>0)
    {
      doStdInput();

      // respond to input

      if(pInput[INPUT_L] && move==0)
      {
        move=-2;
        for(x=0; x<6; x++)
          thingsc[x].rot-=2;

        destroyWeapon(5-curSc);
        play.curWpn=0;

        play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);
      }

      if(pInput[INPUT_R] && move==0)
      {
        move=2;
        for(x=0; x<6; x++)
          thingsc[x].rot+=2;

        destroyWeapon(5-curSc);
        play.curWpn=0;

        play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);
      }

      if(pInput[INPUT_A1] && move==0)
      {
        if(thingsc[curSc].stat==-1)
          goto usedWpn;

        if(gOpt.lComp==0)
          play.wpn1=5-curSc;
        if(gOpt.lComp==1)
          play.wpn2=5-curSc;

        thingsc[curSc].stat=-1;
        gOpt.lComp++;

        if(gOpt.lComp!=2)
        {
          move=2;
          for(x=0; x<6; x++)
            thingsc[x].rot+=2;

          destroyWeapon(5-curSc);
          play.curWpn=0;
        }

        play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);
      }
      usedWpn:

      if(key[KEY_ESC])
      {
        while(key[KEY_ESC]) { }

        for(x=0; x<maxscspr; x++)
        {
          if(scTile[x])
            destroy_bitmap(scTile[x]);
        }
        destroy_bitmap(mImage);
        destroy_bitmap(mImage2);
        destroy_bitmap(tileXbmp);
        destroy_bitmap(tileYbmp);

        mainMenuInit();
      }

      if(gOpt.lComp==2 && path==64) // end of selection
      {
        stopMOD();
        drawTransform(2,6);

        for(x=0; x<maxscspr; x++)
        {
          if(scTile[x])
            destroy_bitmap(scTile[x]);
        }
        destroy_bitmap(mImage);
        destroy_bitmap(mImage2);
        destroy_bitmap(tileXbmp);
        destroy_bitmap(tileYbmp);

        play.curWpn=play.wpn1;

        return;
      }

      if(gOpt.lComp==2)  // hack to get the game to draw one more frame of animation
      {
        path=64;
        move=0;
        sCountDrawOk=1;
      }

      // move sc pointer and rotate icons

      if(move!=0)
      {
        if(move>=1)
        {
          move+=2;
          for(x=0; x<6; x++)
          {
            thingsc[x].rot+=2;

            if(thing[x].rot>256)
              thing[x].rot-=256;
          }

          if(move>=42)
          {
            move=0;
            curSc--;
            if(curSc==-1)
              curSc=5;

            createWeapon(5-curSc);
            play.curWpn=5-curSc;
          }
        }

        if(move<=-1)
        {
          move-=2;
          for(x=0; x<6; x++)
            thingsc[x].rot-=2;

          if(move<=-42)
          {
            move=0;
            curSc++;
            if(curSc==6)
              curSc=0;

            createWeapon(5-curSc);
            play.curWpn=5-curSc;
          }
        }

        if(move==0) // done moving
        {
          pMoveTimer=32;
        }
      }

      // flash

      if(flash==0)
        flash=1;
      else
        flash=0;

      // tile x & y

      tileX+=0.5;
      if(tileX>=20)
        tileX-=20;

      tileY+=0.5;
      if(tileY>=20)
        tileY-=20;

      for(x=0; x<8; x++)
        pInput[x]=0;
      if(move==0)
        pInput[INPUT_A1]=1;

      if(play.curWpn==WEAPON_PLASMA || play.curWpn==WEAPON_VELOCITY)
      {
        pMoveTimer++;
        if(pMoveTimer>128)
          pMoveTimer=0;

        if(pMoveTimer<32)
          pInput[INPUT_L]=1;
        else if(pMoveTimer>=32 && pMoveTimer<64)
          { pInput[INPUT_L]=0; pInput[INPUT_R]=0; }
        else if(pMoveTimer>=64 && pMoveTimer<96)
          pInput[INPUT_R]=1;
        else if(pMoveTimer>=96 && pMoveTimer<128)
          { pInput[INPUT_L]=0; pInput[INPUT_R]=0; }
      }

      doPlayer();      // weapon preview
      doPlayerInput(); // weapon preview
      doThings();      // weapon preview
      doCircles();     // weapon preview

      player.x=24;
      player.y=150-34;
      player.z=0;

      gCount++;

      waitCounter();
    }

    if(sCountDrawOk==1)
    {
      draw_sprite(buffer,mImage2,23,45); // background galaxy image

      if(move==0)
        drawText(buffer,scText[5-curSc],176,204,0); // draw weapon description

      /*sprintf(scText[0],"%f",thingsc[0].rot);
      drawText(buffer,scText[0],184,212,0);
      sprintf(scText[0],"%f",thingsc[0].rot/40.74367);
      drawText(buffer,scText[0],184,220,0);*/

      // draw sprites

      for(x=0; x<6; x++)
      {
        rotPos(thingsc[x].x,thingsc[x].y,thingsc[x].rot/40.74367);

        rx/=2.6; ry/=2.6;
        rx+=100; ry+=116;

        if(thingsc[x].stat==0)
          draw_sprite(buffer,scTile[thingsc[x].sprite],rx,ry);
        else
          draw_sprite(buffer,scTile[6],rx,ry);

        // text

        if(5-x==0)
        {
          drawText(buffer,"Bots",(rx+13)-(4*4),ry-8,64);
        }
        if(5-x==1)
        {
          drawText(buffer,"Velocity",(rx+13)-(8*4),ry-16,64);
          drawText(buffer,"Cannon",(rx+13)-(6*4),ry-8,64);
        }
        if(5-x==2)
        {
          drawText(buffer,"Spread",(rx+13)-(6*4),ry-16,64);
          drawText(buffer,"Laser",(rx+13)-(5*4),ry-8,64);
        }
        if(5-x==3)
        {
          drawText(buffer,"Missles",(rx+13)-(7*4),ry-8,64);
        }
        if(5-x==4)
        {
          drawText(buffer,"Implosion",(rx+13)-(9*4),ry-8,64);
        }
        if(5-x==5)
        {
          drawText(buffer,"Plasma",(rx+13)-(6*4),ry-16,64);
          drawText(buffer,"Stream",(rx+13)-(6*4),ry-8,64);
        }

        // rectangles

        if(curSc==x && flash==1 && move==0)
          rect(buffer,rx,ry,rx+26,ry+17,colWhite);
        else
          rect(buffer,rx,ry,rx+26,ry+17,getColor(53));
      }

      // draw scrolling tiles

      for(x=0; x<14; x++)
        draw_sprite(buffer,tileXbmp,(x*20)+tileX,0);

      for(x=0; x<15; x++)
        draw_sprite(buffer,tileYbmp,0,(x*20)+tileY);

      sortThings();      // weapon preview
      drawScreenMini();  // weapon preview
      blit(bgBuffer,buffer,0,0,205,48,73,150);    // draw weapon preview
      rect(buffer,205,48,205+73,150+48,colWhite);
      rect(buffer,206,49,204+73,149+48,colBlack);

      draw_sprite(buffer,mImage,0,0); // border image

      blitToScreen();

      sCountDrawOk=0;
    }
  }
}

void drawScreenMini()
{
  int sprFlash,x,y,z;
  int drawFlicker=0;

  clear_to_color(bgBuffer,colGray);

  // set background scroll position

  bgPosX=0;

  // draw things, backgrounds, player

  for(x=0; x<tCount; x++)
  {
    y=oSort[x].num;

    if(y>=maxthing) // special for non-things (player, bg, shrapnel)
    {
      if(y==600)
      {
        draw_sprite(bgBuffer,sprPlay[player.sprite],player.x-bgPosX,player.y);
      }

      goto skip;
    }

    if(thing[y].sprite==888 || sprMain[thing[y].sprite]==NULL)
      goto skip;

    if(thingDef[thing[y].type].com[THINGDEF_FLICKER]==1 && drawFlicker%2==0)
      goto skip;

    sprFlash=0;
    if(thing[y].flash==1 && thing[y].sprite+maxsprite2<maxsprite)
    {
      if(sprMain[thing[y].sprite+maxsprite2]!=NULL)
      {
        thing[y].sprite+=maxsprite2;
        sprFlash=1;
      }
    }

    for(z=0; z<maxtcirc; z++) // circles below thing
      if(thing[y].circ[z]!=-1 && circ[thing[y].circ[z]].pos==0)
        drawCircleMini(y,z);

    // draw the thing

    if(thingDef[thing[y].type].com[THINGDEF_TRANS]==1) // transparent sprite
    {
      draw_trans_sprite(bgBuffer,sprMain[thing[y].sprite],
      calctX(thing[y].x+thing[y].offX,thing[y].z)-bgPosX,
      calctY(thing[y].y+thing[y].offY,thing[y].z));
      goto skip;
    }

    if(thing[y].z<1 && thing[y].z>-1) // thing doesn't need any scaling
    {
      if(thing[y].rot==0 && thing[y].sprRot==0) // plain ol sprite draw .. no rotation, no z scaling
        draw_sprite(bgBuffer,sprMain[thing[y].sprite],thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY);
      else
      {
        if(thingDef[thing[y].type].com[THINGDEF_ROTCENTX]==0 && thingDef[thing[y].type].com[THINGDEF_ROTCENTY]==0)
        {
          if(thing[y].rot==64)
            draw_sprite_h_flip(bgBuffer,sprMain[thing[y].sprite],thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY);
          else if(thing[y].rot==128)
            draw_sprite_v_flip(bgBuffer,sprMain[thing[y].sprite],thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY);
          else if(thing[y].rot==192)
            draw_sprite_vh_flip(bgBuffer,sprMain[thing[y].sprite],thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY);
          else
            rotate_sprite(bgBuffer,sprMain[thing[y].sprite],thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY,ftofix(thing[y].rot)); // rotated sprite
        }
        else
          pivot_sprite(bgBuffer,sprMain[thing[y].sprite],
                       thing[y].x+thing[y].offX-bgPosX,thing[y].y+thing[y].offY,
                       thingDef[thing[y].type].com[THINGDEF_ROTCENTX],thingDef[thing[y].type].com[THINGDEF_ROTCENTY],ftofix(thing[y].rot)); // pivoted sprite
      }
    }

    for(z=0; z<maxtcirc; z++) // circles above thing
      if(thing[y].circ[z]!=-1 && circ[thing[y].circ[z]].pos==1)
        drawCircleMini(y,z);

    if(sprFlash==1) // hit flash
    {
      if(thing[y].flash==1)
      {
        thing[y].sprite-=maxsprite2; 
      }
    }

    skip:;
  }
}

void drawCircleMini(int tNum, int cNum)
{
  int x2=0,y2=0,x3=0,y3=0,a=0,b=0,theC=0,fColor=0,oColor=0;

  theC=thing[tNum].circ[cNum];

  // calculate circle size

  x3=calctX(circ[theC].size,thing[tNum].z*-1)/6;

  if(circ[theC].vib==1)
  {
    if(gCount%2==0)
      x3++;
    else
      x3+=2;
  }

  if(circ[theC].vib==2)
  {
    x3+=rand()%6;
    x3-=rand()%6;
  }

  if(circ[theC].vib==3)
  {
    x3+=rand()%3;
    x3-=rand()%3;
  }

  if(x3>0)
  {
    if(circ[theC].trans!=0) // if transparent
      setTrans(1);

    if(thing[tNum].rot==0 || thing[tNum].rot==64 || thing[tNum].rot==128 || thing[tNum].rot==192)
    {
      x2=circ[theC].x; y2=circ[theC].y;
    }
    else
    {
      a=thing[tNum].w2; b=thing[tNum].h2;

      rotPos(circ[theC].x-a,circ[theC].y-b,thing[tNum].rot/41);
      x2=rx+a; y2=ry+b;
    }

    if(thing[tNum].z==0)
    {
      x2+=thing[tNum].x;
      y2+=thing[tNum].y;
    }
    else
    {
      x2=calctX(thing[tNum].x+x2,thing[tNum].z);
      y2=calctY(thing[tNum].y+y2,thing[tNum].z);
    }

    fColor=circ[theC].fColor;
    oColor=circ[theC].oColor;

    if(circ[theC].type==0) // draw a circle
    {
      if(circ[theC].trans==0 || circ[theC].trans==1)
      {
        if(circ[theC].fColor!=0)
          circlefill(bgBuffer,x2-bgPosX,y2,x3,fColor);
        if(circ[theC].oColor!=0)
          circle(bgBuffer,x2-bgPosX,y2,x3,oColor);
      }
      if(circ[theC].trans==2)
      {
        for(a=10; a<20; a++)
        {
          circlefill(bgBuffer,x2-bgPosX,y2,x3-(a/10),fColor);
        }
        if(circ[theC].oColor!=0)
          circle(bgBuffer,x2-bgPosX,y2,x3,oColor);
      }
    }

    if(circ[theC].trans!=0) // if transparent, change back
      setTrans(0);
  }
}

void scoreAttack(int checkScore) // uses counter
{
  int offY,offYnext,lvlNum,inputDown,x;
  char text[64];

  lvlNum=0;

  while(mouse_b & 1 || key[KEY_ESC] || key[KEY_ENTER] || pInput[INPUT_A1]) { updateInput(); }

  if(checkScore==1)
  {
    rectfill(screen,sXoff+1,sYoff-19,sXoff+276,sYoff-2,0); // clear status

    lvlNum=gOpt.lOrder[0];

    if(play.score>hs2[lvlNum].score)
    {
      hs2[lvlNum].score=play.score;
      sprintf(hs2[lvlNum].name,"%s",hiScoreAddName(-1));
      saveHiscore();
    }

    openMOD(getPath("mod/menu.xm"));
  }

  resetCounter();
  for(;;)
  {
    while(sCount>0)
    {
      doStdInput();

      if(!pInput[INPUT_U] && !pInput[INPUT_D])
        inputDown=0;

      if(pInput[INPUT_U] && inputDown==0)
      {
        lvlNum--;
        if(lvlNum==-1)
          lvlNum=8;

        play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);

        inputDown=1;
      }

      if(pInput[INPUT_D] && inputDown==0)
      {
        lvlNum++;
        if(lvlNum==9)
          lvlNum=0;

        play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);

        inputDown=1;
      }

      if(key[KEY_ESC])
      {
        play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);
        mainMenu();
      }

      if(pInput[INPUT_A1] && (lvlNum<2 || lvlNum==8))
      {
        play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);

        if(lvlNum==8)
          mainMenu();

        gOpt.gameMode=1;

        weaponSelect();

        initGame();
        gOpt.lOrder[0]=lvlNum;
        gOpt.skillVar=0;
        shieldAdd=-0.24;

        loadLevel(lvlNum);
        gameLoop();
      }

      waitCounter();
    }

    if(sCountDrawOk==1)
    {
      clear(buffer);

      offY=8;
      offYnext=16;

      drawText(buffer,"Select a level",2,offY,0);
      offY+=offYnext;

      drawText(buffer,"  Level Name Score",2,offY,0);
      offY+=offYnext;

      for(x=0; x<8; x++)
      {
        if(lvlNum==x)
        {
          sprintf(text, "> %i     %s  %i",x+1,hs2[x].name,hs2[x].score);
          drawText(buffer,text,2,offY,0);
        }
        else
        {
          sprintf(text, "  %i     %s  %i",x+1,hs2[x].name,hs2[x].score);
          drawText(buffer,text,2,offY,64);
        }
        offY+=offYnext;
      }

      if(lvlNum==8)
        drawText(buffer,"> Back to Main Menu",2,offY,0);
      else
        drawText(buffer,"  Back to Main Menu",2,offY,64);
      offY+=offYnext;

      blitToScreen();

      sCountDrawOk=0;
    }
  }
}

void options() // uses counter
{
  int x,m1hit,mX,mY,m1,offX,offY,offYnext,oldVmode,curVmode,inputDown=0;
  int mPos=0;

  char text[64];
  char randMode[2][8];
  char skillMode[8][64];
  char expMode[8][64];
  char resMode[8][64];

  sprintf(randMode[0],"Normal");
  sprintf(randMode[1],"Random");

  sprintf(skillMode[0],"0: I just wet my panties!     ");
  sprintf(skillMode[1],"1: Pink bullets scare me      ");
  sprintf(skillMode[2],"2: I like to blow stuffs up   ");
  sprintf(skillMode[3],"3: I'd like my ship well-done ");
  sprintf(skillMode[4],"4: I am totally out of my mind");
  sprintf(skillMode[5],"5: Bruitalize my crotch       ");
  sprintf(skillMode[6],"6: GO 'XOP'- FOR GREAT JUSTICE");

  sprintf(expMode[0],"0: Normal     ");
  sprintf(expMode[1],"1: Excessive  ");
  sprintf(expMode[2],"2: Gratuitous ");
  sprintf(expMode[3],"3: Apocalyptic");
  sprintf(expMode[4],"4: Got RAM?   ");
  sprintf(expMode[5],"5: Got Cray?  ");

  sprintf(resMode[0],"640x480 (Tall)      ");
  sprintf(resMode[1],"512x384 (Tall)      ");
  sprintf(resMode[2],"360x360 (Even)      ");
  sprintf(resMode[3],"400x300 (Tall)      ");
  sprintf(resMode[4],"320x320 (Fullscreen)");

  if(gOpt.expMode==10)
    gOpt.expMode=5;

  oldVmode=gOpt.vMode;
  curVmode=gOpt.vMode;

  while(mouse_b & 1 || pInput[INPUT_A1]) { updateInput(); }

  resetCounter();
  for(;;)
  {
    while(sCount>0)
    {
      mX=mouse_x+15;
      mY=mouse_y+15;
      offX=sXoff+2;
      offY=sYoff+2;
      offYnext=16;
      m1hit=0;

      doStdInput();

      if(!pInput[INPUT_U] && !pInput[INPUT_D] && !pInput[INPUT_L] && !pInput[INPUT_R] && !pInput[INPUT_A1])
        inputDown=0;

      if((pInput[INPUT_D] || pInput[INPUT_U]) && inputDown==0)
      {
        if(pInput[INPUT_D])
        {
          mPos++;
          if(mPos==10)
            mPos=0;
        }

        if(pInput[INPUT_U])
        {
          mPos--;
          if(mPos==-1)
            mPos=9;
        }

        if(mPos>=0 && mPos<=2)
          position_mouse(offX-10,(offY-10)+(mPos*offYnext));
        else if(mPos>=3 && mPos<=5)
          position_mouse(offX-10,(offY-10)+((mPos-4)*(offYnext+8))+80);
        else if(mPos>=6 && mPos<=9)
          position_mouse(offX-10,(offY-10)+((mPos-7)*(offYnext))+152);

        play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);

        inputDown=1;
      }

      if(pInput[INPUT_R] && inputDown==0) // up
      {
        if(mPos==0) // sound
        {
          if(gOpt.soundVol<256)
            gOpt.soundVol+=16;
        }
        if(mPos==1) // music
        {
          if(gOpt.musicVol<256)
            gOpt.musicVol+=16;
        }
        if(mPos==2) // rand mode
        {
          if(gOpt.randMode==0)
            gOpt.randMode=1;
          else
            gOpt.randMode=0;
        }
        if(mPos==3) // skill
        {
          if(gOpt.skillMode<5)
            gOpt.skillMode+=1;
        }
        if(mPos==4) // explosion
        {
          if(gOpt.expMode<4)
            gOpt.expMode+=1;
        }
        if(mPos==5) // res
        {
          if(gOpt.vMode!=0)
            gOpt.vMode-=1;
        }

        inputDown=1;
      }

      if(pInput[INPUT_L] && inputDown==0) // down
      {
        if(mPos==0) // sound
        {
          if(gOpt.soundVol>0)
            gOpt.soundVol-=16;
        }
        if(mPos==1) // music
        {
          if(gOpt.musicVol>0)
            gOpt.musicVol-=16;
        }
        if(mPos==2) // rand mode
        {
          if(gOpt.randMode==0)
            gOpt.randMode=1;
          else
            gOpt.randMode=0;
        }
        if(mPos==3) // skill
        {
          if(gOpt.skillMode!=0)
            gOpt.skillMode-=1;
        }
        if(mPos==4) // explosion
        {
          if(gOpt.expMode!=0)
            gOpt.expMode-=1;
        }
        if(mPos==5) // res
        {
          if(gOpt.vMode!=4)
            gOpt.vMode+=1;
        }

        inputDown=1;
      }

      if(pInput[INPUT_A1] && inputDown==0) // button
      {
        if(mPos==6) // test resolution
        {
          if(gOpt.vMode!=oldVmode && gOpt.vMode!=curVmode)
          {
            if(setScreenRes(0,gOpt.vMode)!=0)
              setScreenRes(0,oldVmode);
            else
              curVmode=gOpt.vMode;

            drawGameBorder();
          }
        }
        if(mPos==7) // save
        {
          saveOptions();
        }
        if(mPos==8) // load
        {
          loadOptions();
        }
        if(mPos==9) // main menu
        {
          play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);

          if(gOpt.vMode!=oldVmode)
          {
            if(setScreenRes(0,gOpt.vMode)!=0)
              setScreenRes(0,oldVmode);

            drawGameBorder();
          }

          position_mouse((90-7)+sXoff,(190-7)+sYoff);
          mainMenu();
        }

        inputDown=1;
      }

      if((pInput[INPUT_L] || pInput[INPUT_R] || pInput[INPUT_A1]) && inputDown==0) // toggle/button
      {
        if(mPos==2) // enemy type
        {
          if(gOpt.randMode==0)
            gOpt.randMode=1;
          else
            gOpt.randMode=0;
        }
        m1hit=1;

        inputDown=1;
      }

      offX=sXoff+244;

      m1=(mouse_b & 1);

      if(m1 && mX>=offX && mX<=offX+12 && mY>=offY && mY<=offY+11) // sound up
      {
        if(gOpt.soundVol<256)
          gOpt.soundVol+=16;
        m1hit=1;
      }
      if(m1 && mX>=offX+15 && mX<=offX+27 && mY>=offY && mY<=offY+11) // sound down
      {
        if(gOpt.soundVol>0)
          gOpt.soundVol-=16;
        m1hit=1;
      }
      offY+=offYnext;

      if(m1 && mX>=offX && mX<=offX+12 && mY>=offY && mY<=offY+11) // music up
      {
        if(gOpt.musicVol<256)
          gOpt.musicVol+=16;
        m1hit=1;
      }
      if(m1 && mX>=offX+15 && mX<=offX+27 && mY>=offY && mY<=offY+11) // music down
      {
        if(gOpt.musicVol>0)
          gOpt.musicVol-=16;
        m1hit=1;
      }
      offY+=offYnext;

      if(m1 && mX>=offX && mX<=offX+12 && mY>=offY && mY<=offY+11) // random 0
      {
        gOpt.randMode=0;
        m1hit=1;
      }
      if(m1 && mX>=offX+15 && mX<=offX+27 && mY>=offY && mY<=offY+11) // random 1
      {
        gOpt.randMode=1;
        m1hit=1;
      }
      offY+=offYnext+8;

      if(m1 && mX>=offX && mX<=offX+12 && mY>=offY && mY<=offY+11) // skill up
      {
        if(key[KEY_X])  // zig mode
        {
          gOpt.skillMode=6;
        }
        else
        {
          if(gOpt.skillMode<5)
            gOpt.skillMode+=1;
        }

        m1hit=1;
      }
      if(m1 && mX>=offX+15 && mX<=offX+27 && mY>=offY && mY<=offY+11) // skill down
      {
        if(gOpt.skillMode!=0)
          gOpt.skillMode-=1;
        m1hit=1;
      }
      offY+=offYnext+8;

      if(m1 && mX>=offX && mX<=offX+12 && mY>=offY && mY<=offY+11) // explosion up
      {
        if(key[KEY_E]) // got cray mode
        {
          gOpt.expMode=5;
        }
        else
        {
          if(gOpt.expMode<4)
            gOpt.expMode+=1;
        }
        m1hit=1;
      }
      if(m1 && mX>=offX+15 && mX<=offX+27 && mY>=offY && mY<=offY+11) // explosion down
      {
        if(gOpt.expMode!=0)
          gOpt.expMode-=1;
        m1hit=1;
      }
      offY+=offYnext+8;

      if(m1 && mX>=offX && mX<=offX+12 && mY>=offY && mY<=offY+11) // res up
      {
        if(gOpt.vMode!=0)
          gOpt.vMode-=1;
        m1hit=1;
      }
      if(m1 && mX>=offX+15 && mX<=offX+27 && mY>=offY && mY<=offY+11) // res down
      {
        if(gOpt.vMode!=4)
          gOpt.vMode+=1;
        m1hit=1;
      }
      offY+=offYnext+16;

      offX=sXoff+2;
      offYnext=16;

      if(m1 && mX>=offX && mX<=offX+140 && mY>=offY && mY<=offY+8) // test resolution
      {
        if(gOpt.vMode!=oldVmode && gOpt.vMode!=curVmode)
        {
          if(setScreenRes(0,gOpt.vMode)!=0)
            setScreenRes(0,oldVmode);
          else
            curVmode=gOpt.vMode;

          drawGameBorder();
        }

        m1hit=1;
      }
      offY+=offYnext;

      if(m1 && mX>=offX && mX<=offX+140 && mY>=offY && mY<=offY+8) // save
      {
        saveOptions();
        m1hit=1;
      }
      offY+=offYnext;

      if(m1 && mX>=offX && mX<=offX+140 && mY>=offY && mY<=offY+8) // load
      {
        loadOptions();
        m1hit=1;
      }
      offY+=offYnext;

      if((m1 && mX>=offX && mX<=offX+140 && mY>=offY && mY<=offY+8) || key[KEY_ESC]) // main menu
      {
        play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);

        if(gOpt.vMode!=oldVmode && gOpt.vMode!=curVmode)
        {
          if(setScreenRes(0,gOpt.vMode)!=0)
          {
            setScreenRes(0,oldVmode);
            gOpt.vMode=oldVmode;
          }

          drawGameBorder();
        }

        mainMenu();
      }
      offY+=offYnext;

      if(m1)
        while(mouse_b & 1) { }

      if(m1hit==1)
      {
        play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);
        set_mod_volume(gOpt.musicVol);
      }

      waitCounter();
    }

    if(sCountDrawOk==1)
    {
      clear(buffer);

      offX=244;
      offY=2;
      offYnext=16;

      draw_sprite(buffer,sprPlay[14],offX,offY); offY+=offYnext;
      draw_sprite(buffer,sprPlay[14],offX,offY); offY+=offYnext;
      draw_sprite(buffer,sprPlay[15],offX,offY); offY+=offYnext+8;
      draw_sprite(buffer,sprPlay[14],offX,offY); offY+=offYnext+8;
      draw_sprite(buffer,sprPlay[14],offX,offY); offY+=offYnext+8;
      draw_sprite(buffer,sprPlay[14],offX,offY); offY+=offYnext+8;

      offX=2;
      offY=2;
      offYnext=8;

      sprintf(text,"Sound:");
      drawText(buffer,text,offX,offY,0);
      x=gOpt.soundVol/4;
      if(x>64)
        x=64;
      if(x>0)
        rectfill(buffer,offX+104,offY+2,offX+104+x,offY+5,colBlue);
      rect(buffer,offX+104,offY+2,offX+104+64,offY+5,colGray);
      offY+=offYnext*2;

      sprintf(text,"Music:");
      drawText(buffer,text,offX,offY,0);
      x=gOpt.musicVol/4;
      if(x>64)
        x=64;
      if(x>0)
        rectfill(buffer,offX+104,offY+2,offX+104+x,offY+5,colBlue);
      rect(buffer,offX+104,offY+2,offX+104+64,offY+5,colGray);
      offY+=offYnext*2;

      sprintf(text,"Enemy Shots:");
      drawText(buffer,text,offX,offY,0);
      sprintf(text,"%s   ",randMode[gOpt.randMode]);
      drawText(buffer,text,offX+104,offY,64);
      offY+=offYnext*3;

      sprintf(text,"Skill:");
      drawText(buffer,text,offX,offY,0);
      drawText(buffer,skillMode[gOpt.skillMode],offX,offY+8,64);
      offY+=offYnext*3;

      sprintf(text,"Explosions:");
      drawText(buffer,text,offX,offY,0);
      drawText(buffer,expMode[gOpt.expMode],offX,offY+8,64);
      offY+=offYnext*3;

      sprintf(text,"Screen Resolution:");
      drawText(buffer,text,offX,offY,0);
      drawText(buffer,resMode[gOpt.vMode],offX,offY+8,64);
      offY+=offYnext*4;

      drawText(buffer,"Test Resolution",offX,offY,0);
      offY+=offYnext*2;
      drawText(buffer,"Save Options",offX,offY,0);
      offY+=offYnext*2;
      drawText(buffer,"Load Options",offX,offY,0);
      offY+=offYnext*2;
      drawText(buffer,"Back to Main Menu",offX,offY,0);
      offY+=offYnext*2;

      draw_sprite(buffer,cursor,mouse_x-sXoff,mouse_y-sYoff);

      blitToScreen();

      sCountDrawOk=0;
    }
  }
}

void hiScores(int checkScore) // no counter
{
  int x,updateHS,newScore;
  char text[64];

  updateHS=0;
  newScore=-1;

  // sort scores

  if(checkScore==1)
  {
    sprintf(hs[10].name,"~~~");
    hs[10].skill=gOpt.skillMode;
    hs[10].lComp=gOpt.lComp+1;
    hs[10].score=play.score;
    updateHS=1;
  }

  qsort(hs, hsSize+checkScore, sizeof(highScoreObj),(int(*)(const void *, const void *)) compL);

  // check to see if the new score is on the list

  if(checkScore==1)
  {
    for(x=0; x<10; x++)
    {
      if(hs[x].name[0]==126) // if the new score is on the list, get initials from player
      {
        sprintf(hs[x].name,"%s",hiScoreAddName(x+1));
        newScore=x;
      }
    }
  }

  // write scores

  if(updateHS==1)
    saveHiscore();

  if(checkScore==1)
    openMOD(getPath("mod/menu.xm"));

  // draw the highscore list

  redrawScores:

  dirtyScreen=0;

  rectfill(screen,sXoff,sYoff,sXoff+278,sYoff+300,0);

  rect(screen,sXoff+4,sYoff+4,sXoff+274,sYoff+296,colWhite);
  rect(screen,sXoff+6,sYoff+6,sXoff+272,sYoff+294,colWhite);

  draw_sprite(screen,sprPlay[16],sXoff+70,sYoff+18);

  line(screen,sXoff+10,sYoff+54,sXoff+268,sYoff+54,colWhite);
  line(screen,sXoff+10,sYoff+56,sXoff+268,sYoff+56,colWhite);

  drawText(screen,"    Name Skill Level Score",sXoff+10,sYoff+58,0);

  for(x=0; x<hsSize; x++)
  {
    if(x+1>=10)
      sprintf(text,"%i  %s  %i     %i     %u",x+1,hs[x].name,hs[x].skill,hs[x].lComp,hs[x].score);
    else
     sprintf(text,"0%i  %s  %i     %i     %u",x+1,hs[x].name,hs[x].skill,hs[x].lComp,hs[x].score);

    if(x==newScore)
      drawText(screen,text,sXoff+10,(sYoff+74)+(x*16),0);
    else
      drawText(screen,text,sXoff+10,(sYoff+74)+(x*16),64);
  }

  // wait for input

  while(mouse_b & 1 || key[KEY_ENTER] || key[KEY_ESC] || pInput[INPUT_A1]) { updateInput(); }
  for(;;)
  {
    doStdInput();

    if(dirtyScreen==1)
      goto redrawScores;

    if(mouse_b & 1 || key[KEY_ENTER] || key[KEY_ESC] || pInput[INPUT_A1])
      break;
  }

  play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);

  mainMenu();
}

#define tRingSize 38

char* hiScoreAddName(int place) // uses counter
{
  int x,namePos,ringPos,mTimer,mTimer2,offY;
  float gStripPos1,gStripPos2;
  char text[64];
  char tRing[48];
  BITMAP *hifont,*gStrip,*gStrip2;
  static char newName[4];

  hifont=readPNG(getPath("png/system/xopfonthi.png"));
  gStrip=readPNG(getPath("png/system/menu01c.png"));
  gStrip2=create_bitmap(57,285);
  draw_sprite_vh_flip(gStrip2,gStrip,0,0);
  sprintf(tRing,"ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!?");

  openMOD(getPath("mod/hiscore.xm"));

  gStripPos1=0;
  gStripPos2=(rand()%64)+2;

  bg[0].stat=-1;     // dummy background info for effect
  bg[0].e[0].effect=1;
  bg[0].e[0].eVar[0]=1;
  bg[0].e[0].eVar[1]=2;
  bg[0].e[0].eVar[2]=1;
  bg[0].e[0].eVar[3]=0;

  restartEntry:

  for(x=0; x<4; x++)
    newName[x]=NULL;

  namePos=0;
  ringPos=0;
  mTimer=0;
  mTimer2=1;

  rectfill(screen,sXoff,sYoff,sXoff+278,sYoff+300,0);

  rect(screen,sXoff+4,sYoff+4,sXoff+274,sYoff+296,colWhite);
  rect(screen,sXoff+6,sYoff+6,sXoff+272,sYoff+294,colWhite);

  line(screen,sXoff+67,sYoff+8,sXoff+67,sYoff+293,colWhite);
  line(screen,sXoff+212,sYoff+8,sXoff+212,sYoff+293,colWhite);

  offY=sYoff+12;

  sprintf(text,"Your score");
  drawText(screen,text,(SCREEN_W/2)-(strlen(text)*4),offY,64);
  offY+=8;
  sprintf(text,"%u",play.score);
  drawText(screen,text,(SCREEN_W/2)-(strlen(text)*4),offY,0);
  offY+=16;

  if(place!=-1)
  {
    sprintf(text,"You got %i",place);

    if(place==1)
      sprintf(text,"%sst",text);
    else if(place==2)
      sprintf(text,"%snd",text);
    else if(place==3)
      sprintf(text,"%srd",text);
    else
      sprintf(text,"%sth",text);

    sprintf(text,"%s place",text);
  }
  else
    sprintf(text,"Got the highscore!");

  drawText(screen,text,(SCREEN_W/2)-(strlen(text)*4),offY,64);
  offY+=16;

  drawText(screen,"Enter your",(SCREEN_W/2)-(10*4),offY,64);
  offY+=8;
  drawText(screen,"initials",(SCREEN_W/2)-(8*4),offY,64);
  offY+=8;

  clear(buffer); clear(bufStat);

  resetCounter();
  for(;;)
  {
    while(sCount>0)
    {
      doStdInput();

      // respond to input

      if(mTimer==0)
      {
        if(pInput[INPUT_L])
        {
          ringPos--;
          if(ringPos==-1)
            ringPos=tRingSize-1;
        }
        else if(pInput[INPUT_R])
        {
          ringPos++;
          if(ringPos==tRingSize)
            ringPos=0;
        }

        if(pInput[INPUT_L] || pInput[INPUT_R])
        {
          play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);
          mTimer=12;
        }
      }

      if(pInput[INPUT_A1] && mTimer2==0)
      {
        play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);

        newName[namePos]=tRing[ringPos];
        namePos++;
        if(namePos==3)
          goto gotName;

        mTimer2=1;
      }

      if(pInput[INPUT_A2] && mTimer2==0 && namePos!=0)
      {
        play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);
        goto restartEntry;
      }

      if(!pInput[INPUT_A1] && !pInput[INPUT_A2])
        mTimer2=0;

      // timer stuff

      if(mTimer!=0)
        mTimer--;

      gStripPos1+=0.6;
      if(gStripPos1>=285)
        gStripPos1-=285;

      gStripPos2-=0.16;
      if(gStripPos2<=0)
        gStripPos2+=285;

      waitCounter();
    }

    if(sCountDrawOk==1)
    {
      // draw name thing

      x=16*namePos;
      blit(hifont, bufStat, ringPos*16, 0, x, 0, 16, 16);

      line(bufStat,0,18,128,18,0);   line(bufStat,0,20,128,20,0);
      line(bufStat,x,18,x+16,18,15); line(bufStat,x,20,x+16,20,colWhite);

      // draw green strip effect

      clear(bgBuffer);
      draw_sprite(bgBuffer,gStrip,0,gStripPos1);
      draw_sprite(bgBuffer,gStrip,0,gStripPos1-285);
      drawBgEffect(0,buffer);

      draw_trans_sprite(buffer,gStrip2,0,gStripPos2);
      draw_trans_sprite(buffer,gStrip2,0,gStripPos2-285);

      acquire_bitmap(screen);

      blit(bufStat,screen,0,0,sXoff+116,sYoff+80,64,24);
      blit(buffer,screen,0,0,sXoff+8,sYoff+8,57,285);
      blit(buffer,screen,0,0,sXoff+214,sYoff+8,57,285);

      release_bitmap(screen);

      sCountDrawOk=0;
    }
  }

  // got the name, return

  gotName:

  stopMOD();
  drawTransform(2,6);
  destroy_bitmap(hifont);
  destroy_bitmap(gStrip);

  return newName;
}

void credits() // no counter
{
  int offX,offY,offYnext;

  redrawCredits:

  dirtyScreen=0;

  offX=sXoff+2;
  offY=sYoff+2;
  offYnext=8;

  rectfill(screen,sXoff,sYoff,sXoff+278,sYoff+300,0);

  drawTextCenter(screen,"XOP (c) 2001 Christopher Emirzian",offY,0);
  offY+=offYnext*2;

  drawTextCenter(screen,"Code",offY,0);
  offY+=offYnext;
  drawTextCenter(screen,"Christopher Emirzian",offY,64);
  offY+=offYnext*2;

  drawTextCenter(screen,"Design/Graphics",offY,0);
  offY+=offYnext;
  drawTextCenter(screen,"Tim McFarland",offY,64);
  offY+=offYnext;
  drawTextCenter(screen,"Christopher Emirzian",offY,64);
  offY+=offYnext;
  drawTextCenter(screen,"Jesse Shepherd",offY,64);
  offY+=offYnext;
  drawTextCenter(screen,"Simon Coong",offY,64);
  offY+=offYnext*2;

  drawTextCenter(screen,"Game Design",offY,0);
  offY+=offYnext;
  drawTextCenter(screen,"Christopher Emirzian",offY,64);
  offY+=offYnext;
  drawTextCenter(screen,"Matthew Emirzian",offY,64);
  offY+=offYnext*2;

  drawTextCenter(screen,"Level Design",offY,0);
  offY+=offYnext;
  drawTextCenter(screen,"Christopher Emirzian",offY,64);
  offY+=offYnext*2;

  drawTextCenter(screen,"Music",offY,0);
  offY+=offYnext;
  drawTextCenter(screen,"Christopher Emirzian",offY,64);
  offY+=offYnext;
  drawTextCenter(screen,"Louis Gorenfeld",offY,64);
  offY+=offYnext*2;

  drawTextCenter(screen,"Allegro by Shawn Hargreaves",offY,64);
  offY+=offYnext;
  drawTextCenter(screen,"And many others :)",offY,64);
  offY+=offYnext*2;

  drawTextCenter(screen,"JGMOD by Guan Foo Wah",offY,64);
  offY+=offYnext*2;

  drawTextCenter(screen,"Special thanks to",offY,64);
  offY+=offYnext;
  drawTextCenter(screen,"all the guys at SHMUPS!",offY,64);
  offY+=offYnext*2;

  while(mouse_b & 1 || key[KEY_ENTER] || pInput[INPUT_A1]) { updateInput(); }
  for(;;)
  {
    updateInput();

    if(dirtyScreen==1)
      goto redrawCredits;

    if(mouse_b & 1 || key[KEY_ENTER] || pInput[INPUT_A1] || key[KEY_ESC])
      break;
  }

  play_sample(snd[9], gOpt.soundVol, 128, 1000, FALSE);

  mainMenu();
}

void endLevel() // uses counter
{
  int dBonus,aBonus,pBonus,tBonus,bSc1,bSc2,t,x;
  int offY;
  char text[64];

  if(play.eCreated==0)
    play.eCreated=1;
  if(play.sCreated==0)
    play.sCreated=1;

  if(play.eDestroyed>play.eCreated)
    play.eDestroyed=play.eCreated;
  if(play.sDestroyed>play.sCreated)
    play.sDestroyed=play.sCreated;

  if(gOpt.lComp==2 || gOpt.lComp==5)
    play.lives++;

  dBonus=(play.eDestroyed/play.eCreated)*20000;
  aBonus=(play.sDestroyed/play.sCreated)*20000;
  pBonus=(play.lostLife*20000);
  tBonus=dBonus+aBonus+pBonus;
  bSc1=0; bSc2=0; t=0;

  rectfill(screen,sXoff+1,sYoff-19,sXoff+276,sYoff-2,0); // clear status
  clear(buffer);
  draw_sprite(buffer,sprPlay[17],0,32);
  blit(buffer,screen,0,0,sXoff,sYoff,280,300);

  while(pInput[INPUT_A1])
    updateInput();

  resetCounter();
  for(;;)
  {
    while(sCount>0)
    {
      doStdInput();

      // respond to input

      if(pInput[INPUT_A1] || key[KEY_ESC] || key[KEY_ENTER])
      {
        play.score+=tBonus;
        tBonus=0;
      }

      // stuff

      t++;
      if(t>=120 && tBonus>0)
      {
        for(x=0; x<80+(rand()%10); x++)
        {
          if(tBonus>0)
          {
            tBonus--;
            play.score++;
          }
        }
        if(t%4==0)
          play_sample(snd[6], gOpt.soundVol, 128, 1000, FALSE);

        if(tBonus==0)
          t=0;
      }

      if(tBonus==0 && (t>=120 || pInput[INPUT_A1] || key[KEY_ESC] || key[KEY_ENTER]))
      {
        stopMOD();
        drawTransform(2,6);

        if(gOpt.gameMode==1)
          scoreAttack(1);

        gOpt.lComp++;

        if(gOpt.lComp==2) // special to abandon ship on unfinished game!
        {
          player.dir=-320;
          mainMenuInit();
        }

        loadLevel(gOpt.lOrder[gOpt.lComp]);
        resetCounter();
        return;
      }

      bSc1++;
      if(bSc1>=280)
        bSc1=0;

      bSc2--;
      if(bSc2<=0)
        bSc2=280;

      waitCounter();
    }

    if(sCountDrawOk==1)
    {
      draw_sprite(buffer,sprPlay[18],bSc1,1);   draw_sprite(buffer,sprPlay[18],bSc1-280,1);
      draw_sprite(buffer,sprPlay[18],bSc2,287); draw_sprite(buffer,sprPlay[18],bSc2-280,287);

      line(buffer,0,15,280,15,53);
      line(buffer,0,285,280,285,53);

      if(t%2==0)
        rect(buffer,12,186,267,272,colWhite);
      else
        rect(buffer,12,186,267,272,53);

      rectfill(buffer,13,187,266,271,0);

      offY=187;

      sprintf(text,"Destruction : %i",dBonus);
      drawText(buffer,text,13,offY,0);
      offY+=8;

      drawText(buffer,"              +",13,offY,64);
      offY+=8;

      sprintf(text,"Accuracy    : %i",aBonus);
      drawText(buffer,text,13,offY,0);
      offY+=8;

      drawText(buffer,"              +",13,offY,64);
      offY+=8;

      sprintf(text,"Perfect     : %i",pBonus);
      drawText(buffer,text,13,offY,0);
      offY+=8;

      drawText(buffer,"              =",13,offY,64);
      offY+=8;

      sprintf(text,"Total       : %i",tBonus);
      drawText(buffer,text,13,offY,0);
      offY+=16;

      sprintf(text,"Score       : %u",play.score);
      drawText(buffer,text,13,offY,0);
      offY+=8;

      blitToScreen();

      sCountDrawOk=0;
    }
  }
}

void splashScreen() // no counter
{
  BITMAP *toast;

  toast=readPNG(getPath("png/system/toast.png"));

  set_pallete(black_pallete);
  blit(toast,screen,0,0,sXoff,sYoff,280,300);

  fade_in_range(pal,4,0,255);

  for(;;)
  {
    updateInput();
    if(mouse_b & 1 || key[KEY_ENTER] || key[KEY_ESC] || pInput[INPUT_A1])
      break;
  }

  fade_out_range(4,0,255);

  clear(screen);

  destroy_bitmap(toast);
}