/* XOP source code (c) 2001 Christopher Emirzian
   All Rights Reserved

   Description: Shrapnel loop, shrapnel maker
*/

#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <allegro.h>
#include "jgmod.h"
#include <png.h>

//#include "loadpng.h"
#include "main.h"
#include "system.h"
#include "thing.h"
//#include "tmake.h"
//#include "draw.h"
//#include "level.h"
//#include "input.h"
#include "shrap.h"
#include "play.h"
//#include "file.h"
//#include "unpack.h"
//#include "menu.h"

void makeShrapDef(int ix, int iy, int iz, int sNum, int tNum)
{
  register int z;
  int x,t,l,sLimit=0;
  float sx,sy,sz,grav,rot;

  if(shrapDef[sNum].loaded==0)
    bombOut(32,sNum);

  if(shrapDef[sNum].com[12]==0)
    shrapDef[sNum].com[12]=1;

  grav=(float)(shrapDef[sNum].com[6])/100;

  if(shrapDef[sNum].com[22]!=0) // offset x
  {
    ix-=thing[tNum].w2;
    ix+=shrapDef[sNum].com[22];
  }
  if(shrapDef[sNum].com[23]!=0) // offset y
  {
    iy-=thing[tNum].h2;
    iy+=shrapDef[sNum].com[23];
  }

  for(x=2; x<shrapDef[sNum].com[16]+(gOpt.expMode*2); x++) // main loop to make shrapnel
  {
    t=0;
    if(shrapDef[sNum].com[11]!=0)
      t=rand()%shrapDef[sNum].com[11];

    l=(rand()%shrapDef[sNum].com[12])+shrapDef[sNum].com[13];
    l+=gOpt.expMode;
    if(l<=0)
      l=1;

    if(rand()%2==1)
    {
      sx=(float)((rand()%(shrapDef[sNum].com[0]*10))-(shrapDef[sNum].com[1]*10))/100;
      sy=(float)((rand()%(shrapDef[sNum].com[2]*10))-(shrapDef[sNum].com[3]*10))/100;
    }
    else
    {
      sx=(float)((rand()%shrapDef[sNum].com[0])-(shrapDef[sNum].com[1]))/10;
      sy=(float)((rand()%shrapDef[sNum].com[2])-(shrapDef[sNum].com[3]))/10;
    }
    sz=(float)((rand()%(shrapDef[sNum].com[4]))-(shrapDef[sNum].com[5]))/10;

    rot=shrapDef[sNum].com[20];
    if(rot!=0)
    {
      if(rot==888)
        rot=rand()%256;
      if(rot==889)
        rot=thing[tNum].rot;

      rotPos(sx,sy,rot/41);
      sx=rx; sy=ry;
    }

    if(shrapDef[sNum].com[14]==1)
      sy+=play.speed;

    if(shrapDef[sNum].com[15]==1)
    {
      sx+=thing[tNum].sx/2;
      sy+=thing[tNum].sy/2;
      sz+=thing[tNum].sz/2;
    }

    for(z=sLimit; z<maxshrap; z++) // make one piece of shrapnel
    {
      if(sh[z].type==-1)
      {
        sh[z].x=ix;
        sh[z].y=iy;
        sh[z].z=iz;
        sh[z].xspd=sx;
        sh[z].yspd=sy;
        sh[z].zspd=sz;

        sh[z].grav=grav;
        sh[z].type=t;
        sh[z].life=l;
        sh[z].hiDraw=shrapDef[sNum].com[21];

        sh[z].col[0]=shrapDef[sNum].com[7];
        sh[z].col[1]=shrapDef[sNum].com[8];
        sh[z].col[2]=shrapDef[sNum].com[9];
        sh[z].col[3]=shrapDef[sNum].com[10];

        sh[z].colShow=rand()%4;
        sh[z].cycle=0;
        sh[z].cLimit=shrapDef[sNum].com[17];
        if(sh[z].cLimit==888)
          sh[z].cLimit=(rand()%16)+4;
        sh[z].pDrop=shrapDef[sNum].com[18];

        goto madeShrap;
      }
    }
    return; // if we reached here, there's no more shrap to use!

    madeShrap:;
    sLimit=z;
  }

  x=shrapDef[sNum].com[19];
  if(x!=0 && x!=sNum)
    makeShrapDef(ix,iy,iz,x,tNum);
}

void doShrap()
{
  register int x;

  for(x=0; x<sMax; x++)
  {
    if(sh[x].type!=-1)
    {
      sh[x].x+=sh[x].xspd;
      sh[x].y+=sh[x].yspd;
      sh[x].z+=sh[x].zspd;
      sh[x].zspd-=sh[x].grav;

      if(sh[x].cLimit!=0)
      {
        sh[x].cycle++;
        if(sh[x].cycle==sh[x].cLimit)
        {
          sh[x].cycle=0;

          sh[x].colShow++;
          if(sh[x].colShow==4)
            sh[x].colShow=0;
        }
      }

      sh[x].life--;
      if(sh[x].life==0)
        sh[x].type=-1;
    }
  }
}
